use std::path::PathBuf;

use viperid::VResult;

use crate::go_builder::GoBuilder;

mod go_builder;

fn main() -> VResult<()> {
    let builder = GoBuilder::new(
        &PathBuf::from("example_project"))?;
    let wasm = builder.build()?;
    let mut executor = player::Executor::new(&wasm)?;

    while executor.is_running() {
        println!("update started");
        executor.update();
        println!("update completed");
        executor.get_error()?;
    }

    Ok(())
}
