use std::fmt::Display;

use viperid::VResult;
use wasmi::{core::{HostError, Trap}, Caller, Linker};

use crate::executor::ExecutorState;

pub(crate) fn integrate(linker: &mut Linker<ExecutorState>) -> VResult<()> {
    linker.func_wrap("viperid", "YieldFrame", yield_frame)?;

    Ok(())
}

fn yield_frame(caller: Caller<ExecutorState>) -> Result<(), Trap> {
    Err(Trap::from(YieldFrame {}))
}

#[derive(Debug)]
pub(crate) struct YieldFrame {

}

impl Display for YieldFrame {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        f.write_str("<device wants to display a frame>")
    }
}

impl HostError for YieldFrame {

}
